/*
 * htmlHighlighter.java
 *
 * Created on October 19, 2001, 8:59 AM
 */

package TextHighlighter;
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *
 * @author  Steven M. Berardi
 * @version 1.0
 */
public class htmlHighlighter extends java.lang.Object {

    private String url;
    private String text; //source text
    private String trigger; //what to highlight
    
    private String filename; //output filename (html file)
    
    private String foreColor; //fore color of highlighted text
    private String backColor; //back color of highlighted text

    private byte[] FileData;
    
    /** Creates new htmlHighlighter */
    public htmlHighlighter() {        
    }
  //--------------------------------------------------------------------------//
    public void   setSourceURL(String url) {  this.url = url;   }   
    public String getSourceURL()           {  return this.url;  }
    
    public void   setText(String text) {  this.text = text;  }
    public String getText()            {  return this.text;  }
    
    public void   setTrigger(String trigger) {  this.trigger = trigger;  }
    public String getTrigger()               {  return this.trigger;     }
    
    public void   setFilename(String filename) {  this.filename = filename;  }
    public String getFilename()                {  return this.filename;      }
    
    public void   setForeColor(String foreColor) {  this.foreColor = foreColor;  }
    public String getForeColor()                 {  return this.foreColor;       }
    
    public void   setBackColor(String backColor) {  this.backColor = backColor;  }
    public String getBackColor()                 {  return this.backColor;       }
    
  //--------------------------------------------------------------------------//
    
  //--------------------------------------------------------------------------//    
    public void highlight() {
      //main method, used to highlight text.
        String htmlSource = this.getUrlHTML(url);
        StringBuffer newText= new StringBuffer("");
        int StartPos=0;
        int EndPos=htmlSource.length()-1;
        int spos=0;
        
        do{
          spos = htmlSource.toLowerCase().indexOf(trigger, StartPos); //find start pos of trigger
            
          if ( spos < 0 ) {  //trigger NOT found:
              newText.append(htmlSource.substring(StartPos)); //add final part of source code             
              break;
          }
            
          newText.append(htmlSource.substring(StartPos,spos-1)); //append text BEFORE trigger
          newText.append(" <b style=\"color:" + foreColor + ";background-color:" + backColor + "\">" + trigger + "</b>");
                 
          StartPos = spos + trigger.length();
        }while(StartPos < EndPos);
        
        this.FileData = newText.toString().getBytes();                
        
        return;
    } //end : highlight() method
  //--------------------------------------------------------------------------//    
    public void save() {
       FileOutputStream fos;  //output stream object        
        
       try{  //try writing to file
          fos = new FileOutputStream(this.filename); //new file output stream
          
          fos.write(FileData); //write data
          fos.flush();
          fos.close();
       }
       catch (Exception e){  e.printStackTrace();  }
        
       return;        
    } //end : save() method
  //--------------------------------------------------------------------------//    
    

    
    
    
    
    
  //--------------------------------------------------------------------------//
  //     Utility functions - private                                          //
  //--------------------------------------------------------------------------//
    private String getUrlHTML(String SourceURL)
    {
     //returns the html source code for the specified SOURCE_URL
       String htmlSource="";
       
      try
      {
        URL rl = new URL(SourceURL);
        InputStream in = rl.openStream();   //open input stream from html file
        InputStreamReader isr = new InputStreamReader(in);
        BufferedReader br = new BufferedReader(isr);      

        while (br.ready())  //loop while the file IS READY
        {
          String NextLine = br.readLine();  //get next line from html
          if (NextLine != null) {
            htmlSource = htmlSource + NextLine; //append next line...             
          }
        }
      }
      catch(Exception e) {  e.printStackTrace();  }
                                   
        return htmlSource;
    }
  //--------------------------------------------------------------------------//
    
    
    
}  //end htmlHighlighter class....
//------------------------------- end ----------------------------------------//